// membench.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include "timecounter.hpp"
#include "mmx.hpp"
#include "sse.hpp"

int _tmain(int argc, _TCHAR* argv[])
{
	LARGE_INTEGER start;
	LARGE_INTEGER end;
	void* source;
	void* destination;
	int size = 16 * 1024 * 1024;
	int i;
	// 
	TimeCounter_Initialize();
	source = malloc( size );
	destination = malloc( size );
	memset( source, 0, size );
	memset( destination, 0, size );
	// Sleep( 1000 );
	start = TimeCounter_Get();
	Sleep( 1000 );
	end = TimeCounter_Get();
	std::cout << "Sleep( 1000 )    : " << end.QuadPart - start.QuadPart << "us\n";
	// 1 byte copy
	char* source_1byte;
	char* destination_1byte;
	source_1byte = ( char* )source;
	destination_1byte = ( char* )destination;
	start = TimeCounter_Get();
	for( i = 0; i < size; i ++ )
	{
		destination_1byte[ i ] = source_1byte[ i ];
	}
	end = TimeCounter_Get();
	std::cout << "1byte copy (16MB): " << end.QuadPart - start.QuadPart << "us\n";
	// 4 bytes copy
	int* source_4byte;
	int* destination_4byte;
	source_4byte = ( int* )source;
	destination_4byte = ( int* )destination;
	start = TimeCounter_Get();
	for( i = 0; i < ( size / 4 ); i ++ )
	{
		destination_4byte[ i ] = source_4byte[ i ];
	}
	end = TimeCounter_Get();
	std::cout << "4byte copy (16MB): " << end.QuadPart - start.QuadPart << "us\n";
	// 8 bytes copy
	long long* source_8byte;
	long long* destination_8byte;
	source_8byte = ( long long* )source;
	destination_8byte = ( long long* )destination;
	start = TimeCounter_Get();
	for( i = 0; i < ( size / 8 ); i ++ )
	{
		destination_8byte[ i ] = source_8byte[ i ];
	}
	end = TimeCounter_Get();
	std::cout << "8byte copy (16MB): " << end.QuadPart - start.QuadPart << "us\n";
	// memcpy
	start = TimeCounter_Get();
	memcpy( destination, source, size );
	end = TimeCounter_Get();
	std::cout << "memcpy(16MB)     : " << end.QuadPart - start.QuadPart << "us\n";
	// MMX
	if( MMX_IsEnabled() )
	{
		start = TimeCounter_Get();
		MMX_MemoryCopy( destination, source, size / 8 );
		end = TimeCounter_Get();
		std::cout << "MMXcopy(16MB)    : " << end.QuadPart - start.QuadPart << "us\n";
	}
	// SSE
	if( SSE_IsEnabled() )
	{
		start = TimeCounter_Get();
		SSE_MemoryCopy( destination, source, size / 16 );
		end = TimeCounter_Get();
		std::cout << "SSEcopy(16MB)    : " << end.QuadPart - start.QuadPart << "us\n";
	}
	TimeCounter_Release();
	std::cout << "push any key to end.\n";
	getchar();
	return 0;
}
