#include "mmx.hpp"

bool MMX_IsEnabled( void )
{
	int flag;
	_asm
	{
		push eax
		push ebx
		push ecx
		push edx
		mov eax, 1
		_emit 0x0F
		_emit 0xA2 // cpuid
		mov flag, edx
		pop edx
		pop ecx
		pop ebx
		pop eax
	}
	if( flag & 0x00800000 )
	{
		return true;
	}
	return false;
}

void MMX_MemoryCopy( void* destination, void* source, int align8_size )
{
	_asm
	{
		push eax
		push ebx
		push ecx
		mov eax, destination
		mov ebx, source
		mov ecx, align8_size
	LOOP1:
		movq mm0, [ebx]
		movq [eax], mm0
		add eax, 8
		add ebx, 8
		dec ecx
		jne LOOP1
		emms
		pop ecx
		pop ebx
		pop eax
	}
}
