#include "sse.hpp"

bool SSE_IsEnabled( void )
{
	int flag;
	_asm
	{
		push eax
		push ebx
		push ecx
		push edx
		mov eax, 1
		_emit 0x0F
		_emit 0xA2 // cpuid
		mov flag, edx
		pop edx
		pop ecx
		pop ebx
		pop eax
	}
	if( flag & 0x02000000 )
	{
		return true;
	}
	return false;
}

void SSE_MemoryCopy( void* destination, void* source, int align16_size )
{
	_asm
	{
		push eax
		push ebx
		push ecx
		mov eax, destination
		mov ebx, source
		mov ecx, align16_size
	LOOP1:
		movaps xmm0, [ebx]
		movaps [eax], xmm0
		add eax, 16
		add ebx, 16
		dec ecx
		jne LOOP1
		pop ecx
		pop ebx
		pop eax
	}
}
